#!/bin/bash

#获得当前的zabbix-server-mysql是什么版本
sql_current_zbxDB=$(mysql -h 127.0.0.1 -u zabbix -pzabbix zabbix -e "select versionNUM from zabbix.DBVersion;")

#查询结果包括列号和参数，这是返回第一个参数的函数
function strDeal(){
  echo $2
}
Version=$(strDeal $sql_current_zbxDB)

let count=$Version+1 #下一版本

#找到版本号最大的文件
echo "所有升级脚本："
for file in $(ls update-*|sort -t '-' -k2n) #这个grep可以改成正则表达式匹配
do
    echo $file
done

#获取上一版本号
latest_version=${file%.*}
latest_version=${latest_version#*-}

#从当前版本的下一个版本开始升级直到执行完最后一个升级脚本
function exe_update_sh(){
while [ $count -le $latest_version ]
do
	if [ -e "update-"$count".sh" ]
	then
		sh "update-"$count".sh"
		#执行成功后则更新数据库版本号
		if [ $? == 0 ]
		then
			mysql -h 127.0.0.1 -u zabbix -pzabbix zabbix -e "update DBVersion set versionNUM = $count where versionNum = $count-1"
		echo "数据库升级至版本"$count"成功"
		fi
	fi
	let count+=1
done
}
exe_update_sh
